import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';
import { FileEventJson } from '@ucap/protocol-event';

@Component({
  selector: 'ucap-chat-message-box-image',
  templateUrl: './image.component.html',
  styleUrls: ['./image.component.scss']
})
export class ImageComponent implements OnInit {
  @Input()
  fileInfo: FileEventJson;

  @Input()
  expired = false;

  @Input()
  fileRetentionPeriod?: number;

  @Output()
  openViewer = new EventEmitter();

  constructor() {}

  ngOnInit() {}

  onClickOpenViewer() {
    if (!this.expired) {
      this.openViewer.emit();
    }
  }
}
