import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';

import { FileDownloadItem } from '@ucap/api';

import { FileEventJson } from '@ucap/protocol-event';
import { FileInfo } from '@ucap/protocol-file';

@Component({
  selector: 'ucap-binary-viewer',
  templateUrl: './binary-viewer.component.html',
  styleUrls: ['./binary-viewer.component.scss']
})
export class BinaryViewerComponent implements OnInit {
  @Input()
  fileInfo: FileInfo;

  @Input()
  fileDownloadUrl: string;

  @Output()
  download = new EventEmitter<FileDownloadItem>();

  @Output()
  closed = new EventEmitter<void>();

  fileDownloadItem: FileDownloadItem;

  constructor() {}

  ngOnInit() {}

  onClickDownload(): void {
    this.fileDownloadItem = new FileDownloadItem();
    this.download.emit(this.fileDownloadItem);
  }

  onClickClose(): void {
    this.closed.emit();
  }
}
